# -*- mode: python -*-
# -*- coding: utf-8 -*-

##############################################################################
#
# ScoDoc
#
# Copyright (c) 1999 - 2021 Emmanuel Viennet.  All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   Emmanuel Viennet      emmanuel.viennet@viennet.net
#
##############################################################################

"""
Module main: page d'accueil, avec liste des départements

Emmanuel Viennet, 2021
"""
import flask
from flask import render_template

from scodoc_manager import sco_mgr

from app.views import scodoc_bp as bp
from app.scodoc import VERSION
from app.scodoc.sco_permissions import Permission


@bp.route("/ScoDoc")
@bp.route("/ScoDoc/index")
def index():
    dept_ids = sco_mgr.get_dept_ids()
    return render_template(
        "scodoc.html",
        title=VERSION.SCONAME,
        current_app=flask.current_app,
        dept_ids=dept_ids,
        Permission=Permission,
    )
